typedef struct
{
   USHORT Record_Number;
   CHAR Account_Holder[41];
   CHAR Account_Name[41];
   CHAR Account_Number[41];
   double Account_Balance;
   USHORT Account_Type;
   CHAR Type_Name[41];
   CHAR Active_From[11];
   CHAR Active_To[11];
   CHAR Expired[2];
   ULONG Entries;
} ACCOUNT;


#define AccountRecord_Number        Account->Record_Number
#define AccountAccount_Holder       Account->Account_Holder
#define AccountAccount_Name         Account->Account_Name
#define AccountAccount_Number       Account->Account_Number
#define AccountAccount_Balance      Account->Account_Balance
#define AccountAccount_Type         Account->Account_Type
#define AccountActive_From          Account->Active_From
#define AccountActive_To            Account->Active_To
#define AccountExpired              Account->Expired

typedef struct
{
   ULONG Record_Number;
   USHORT Account_Ref;
   USHORT CrossAcc;
   char Acc_Date[11];
   USHORT Trans_Num;
   double Amount;
   double Balance;
   double CrossBalance;
   char Cleared[2];
   char Chk_Num[21];
   char Payee[61];
   char Memo[61];
   ULONG Category;
   double StmtBal;
   USHORT ChkImg;
} ACC_INFO;

#define AccInfoRecord_Number        Acc_Info->Record_Number
#define AccInfoAccount_Ref          Acc_Info->Account_Ref
#define AccInfoCrossAcc             Acc_Info->CrossAcc
#define AccInfoAcc_Date             Acc_Info->Acc_Date
#define AccInfoTrans_Num            Acc_Info->Trans_Num
#define AccInfoAmount               Acc_Info->Amount
#define AccInfoBalance              Acc_Info->Balance
#define AccInfoCrossBalance         Acc_Info->CrossBalance
#define AccInfoCleared              Acc_Info->Cleared
#define AccInfoChk_Num              Acc_Info->Chk_Num
#define AccInfoPayee                Acc_Info->Payee
#define AccInfoMemo                 Acc_Info->Memo
#define AccInfoCategory             Acc_Info->Category
#define AccInfoStmtBal              Acc_Info->StmtBal
#define AccInfoChkImg               Acc_Info->ChkImg

typedef struct
{
   ULONG Info_Rec_Num;
   ULONG Record_Number;
   CHAR Info_Address[61];

} ACC_ADDRESS;

#define Acc_AddressInfo_Rec_Num     Acc_Address->Info_Rec_Num
#define Acc_AddressRecord_Number    Acc_Address->Record_Number
#define Acc_AddressInfo_Address     Acc_Address->Info_Address

typedef struct
{
   ULONG Record_Number;
   CHAR Description[41];
   USHORT Selected;
} ACCOUNT_TYPES;

#define Account_TypesRecord_Number        Account_Types->Record_Number
#define Account_TypesDescription          Account_Types->Description

typedef struct
{
   ULONG Account_Ref;
   CHAR File_Name[1024];
   CHAR Import_Timestamp[30];
   CHAR Import_Date[11];
   CHAR Import_Time[15];
} IMPORTFILE;

#define ImportFileAccount_Ref       ImportFile->Account_Ref
#define ImportFileFile_Name         ImportFile->File_Name
#define ImportFileImport_Timestamp  ImportFile->Import_Timestamp
#define ImportFileImport_Date       ImportFile->Import_Date
#define ImportFileImport_Time       ImportFile->Import_Time

typedef struct
{
   ULONG Account_Ref;
   ULONG Category;
   char Memo[61];
   double Amount;
} SPLIT_INFO;

#define Split_InfoAccount_Ref       Split_Info->Account_Ref
#define Split_InfoCategory          Split_Info->Category
#define Split_InfoMemo              Split_Info->Memo
#define Split_InfoAmout             Split_Info->Amount


LONG DBStart(void);
LONG DBConnectFinance(void);
LONG DBMakeFinance(PSZ pszDrive);
LONG DBDisconnect(void);
LONG DBCommit(void);
LONG DBRollback(void);
SHORT isDBConnected(void);

LONG DBNumAccounts(ULONG *ulCount);
LONG DBOpenAllAccountCursor(void);
LONG DBFetchAllAccountsCursor(ACCOUNT *Account);
LONG DBCloseAllAccountCursor(void);
LONG DBOpenAccountHolderCursor(void);
LONG DBFetchAccountHolderCursor(ACCOUNT *Account);
LONG DBCloseAccountHolderCursor(void);
LONG DBOpenAccountNameByHolderCursor(ACCOUNT *Account);
LONG DBFetchAccountNameByHolderCursor(ACCOUNT *Account);
LONG DBCloseAccountNameByHolderCursor(void);
LONG DBInsertAccount(ACCOUNT *Account);
LONG DBSelectAccount(ACCOUNT *Account);

LONG DBSelectAccount_Type(ACCOUNT_TYPES *Account_Types);
LONG DBNumAccount_Type(ULONG *ulCount);
LONG DBOpenAccount_TypesCursor(void);
LONG DBFetchAccount_TypesCursor(ACCOUNT_TYPES *Account_Types);
LONG DBCloseAccount_TypesCursor(void);

LONG DBSelectAccountRecNum(ACCOUNT *Account);
LONG DBInsertAccount(ACCOUNT *Account);
LONG DBInsertAccountInfo(ACC_INFO *Acc_Info);
LONG DBSelectAccount_InfoCount(ACC_INFO *Acc_Info);
LONG DBOpenAccount_InfoCursor(ACC_INFO *Acc_Info);
LONG DBFetchAccount_InfoCursor(ACC_INFO *Acc_Info);
LONG DBCloseAccount_InfoCursor(void);
LONG DBInsertAcc_Address(ACC_ADDRESS *Acc_Address);
LONG DBInsertImportFile(IMPORTFILE *ImportFile);
LONG DBSelectImportFile(IMPORTFILE *ImportFile);
LONG DBInsertChkImg(PSZ pszFileName, ULONG ulLen, ULONG Account_Ref);
LONG DBGetChkImg(ULONG Account_Ref, PSZ pszFilename);
LONG DBGetChkCount(ULONG Account_Ref, USHORT *usCount);
LONG DBInsertSplitInfo(SPLIT_INFO *Split_Info);




